SystemOrganization addCategory: #TpTraits!
SystemOrganization addCategory: #'TpTraits-Test'!

Trait named: #Coleccion
	uses: {}
	category: 'TpTraits'!

!Coleccion commentStamp: '<historical>' prior: 0!
metodos de una lista generica
!

!Coleccion methodsFor: 'as yet unclassified' stamp: 'Fiok 9/3/2013 22:13'!
coleccion
	^self requirements! !

!Coleccion methodsFor: 'as yet unclassified' stamp: 'Fiok 9/3/2013 22:13'!
coleccion:unaColeccion
	^self requirements! !

!Coleccion methodsFor: 'as yet unclassified' stamp: 'Fiok 9/3/2013 22:16'!
tamao
	^self coleccion size.! !

Trait named: #InformeGrupos
	uses: {}
	category: 'TpTraits'!

!InformeGrupos commentStamp: '<historical>' prior: 0!
Trait del punto III!

!InformeGrupos methodsFor: 'as yet unclassified' stamp: 'luksdlt92 9/12/2013 01:20'!
actividades
	self requirements.! !

!InformeGrupos methodsFor: 'as yet unclassified' stamp: 'luksdlt92 9/12/2013 01:21'!
actividadesNoAprobadas
"Falta completarlo"
	^self actividades. ! !

Trait named: #Promediable
	uses: {}
	category: 'TpTraits'!

!Promediable commentStamp: '<historical>' prior: 0!
A Promediable is xxxxxxxxx.
!

Trait named: #Estadistica
	uses: Promediable
	category: 'TpTraits'!

!Estadistica commentStamp: '<historical>' prior: 0!
An Estadistica is a Trait that contains methods which implement stats
!

Estadistica classTrait
	uses: Promediable classTrait!

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Javi 9/12/2013 04:14'!
cualEsLaNotaMasAltaAlcanzadaNVeces:n
"Selecciono todas las notas alcanzadas n veces, y devuelvo la mas alta"
^(#(1 2 3 4 5 6 7 8 9 10) select: [:nota | (self obtenerCursadas count: [:cursada| cursada nota >= nota]) >= n ]) max.


! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'fedecasares 9/11/2013 18:08'!
cursadasAprobadas:cursadasCol
"|suma|
suma:=0.
self cursadas do:[:unaCursada|(unaCursada nota >= 4) ifTrue:[suma:=suma+1]].
^suma."

^( cursadasCol select:[:unaCursada|(unaCursada aprobo) &(unaCursada abandono not) ] )size
	! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'fedecasares 9/11/2013 18:07'!
cursosAbandonados: cursosCol
"|suma|
suma:=0.
self cursadasAbandonadas select:[:unaCursada | unaCursada cursos ].
^suma.
	"
	^( cursosCol select:[:unaCursada|(unaCursada aprobo not) &(unaCursada abandono) ] )size! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Javi 9/12/2013 03:52'!
obtenerCursadas 
self requirements

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Javi 9/12/2013 03:44'!
obtenerNumero:algo
self requirements ! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'andres 9/10/2013 22:30'!
obtenerVecNotas
self requirements

! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'andres 9/11/2013 21:55'!
porcentajeAprobadosIniciados: unaCol
^((((self cursadasAprobadas:unaCol)  // (self cursosAbandonados:unaCol))*100)// (unaCol size)).
	! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Javi 9/12/2013 03:52'!
promedioConAplazos
| suma |
	suma:=0.
	self obtenerCursadas do:[:unAlgo| suma:=suma+( unAlgo nota)].
	^suma // self obtenerCursadas size.
	! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Javi 9/12/2013 03:52'!
promedioSinAplazos
| suma colAux|
	suma:=0.
	
	colAux:=self obtenerCursadas select:[:unaCursada|((self obtenerNumero: unaCursada) >= 4)].	
	colAux do:[:unaCursada|suma:=suma+ (self obtenerNumero: unaCursada)].
	^suma // colAux size.! !

!Estadistica methodsFor: 'as yet unclassified' stamp: 'Javi 9/12/2013 03:52'!
tablaDeNotas
|n|
n:=1.
n to:10 do:[:cuantos| (self obtenerVecNotas at:n put:((self obtenerCursadas select:[: unaCursada | unaCursada nota == n]) size)).
	n:=n+1].
^self obtenerVecNotas.

! !

!Promediable methodsFor: 'as yet unclassified' stamp: 'pablo 9/10/2013 11:45'!
obtenerNumero:algo
	^self requirements ! !

!Promediable methodsFor: 'as yet unclassified' stamp: 'Fiok 9/11/2013 20:35'!
promedio:unaColeccion
	| suma |
	suma:=0.
	unaColeccion do:[:unAlgo| suma:=suma+( self obtenerNumero: unAlgo)].
	^suma //unaColeccion  size.! !

TestCase subclass: #TestAlumno
	instanceVariableNames: 'alumno cursada curso1 materia1 materia2 materia3 carrera1 docente1 curso2 curso3 cursada2 cursada3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits-Test'!

!TestAlumno methodsFor: 'as yet unclassified' stamp: 'andres 9/10/2013 10:10'!
setUp
	alumno:= Alumno new.
	cursada:= Cursada new.
	cursada2:= Cursada new.
	cursada3:= Cursada new.
	carrera1 := Carrera new.
	materia1 := Materia  new.
	materia2  := Materia  new.
	materia3  := Materia  new.
	curso1 := Curso new.
	curso2 := Curso new.
	curso3 := Curso new.
	docente1 := Docente new.

	
	alumno carrera: carrera1.
	
	cursada curso: curso1.
	cursada  nota: 7.
	cursada2  curso: curso2.
	cursada2 nota: 9.
	cursada3  curso: curso3.
	cursada3 nota: 2.
	
	cursada estado:2.
	cursada2 estado:2.
	cursada3 estado:1.
	
	alumno cursadas add: cursada.
	alumno cursadas add: cursada2.
	alumno cursadas add: cursada3.
	
	
	! !

!TestAlumno methodsFor: 'as yet unclassified' stamp: 'fedecasares 9/11/2013 18:18'!
testCantidadDeCursadasAbandonadas
self assert: (alumno cursosAbandonados: (alumno cursadas) ) equals:1.! !

!TestAlumno methodsFor: 'as yet unclassified' stamp: 'fedecasares 9/11/2013 18:18'!
testCantidadDeCursadasAprobadas
self assert:(alumno cursadasAprobadas: alumno cursadas ) equals:2.! !

!TestAlumno methodsFor: 'as yet unclassified' stamp: 'Javi 9/12/2013 04:14'!
testCualEsLaNotaMasAlta
self assert: (alumno cualEsLaNotaMasAltaAlcanzadaNVeces:2) equals:7.
! !

!TestAlumno methodsFor: 'as yet unclassified' stamp: 'fedecasares 9/11/2013 18:20'!
testPorcentajeDeCursosAprobadosSobreIniciados
self assert: (alumno porcentajeAprobadosIniciados:(alumno cursadas )) equals:66.! !

!TestAlumno methodsFor: 'as yet unclassified' stamp: 'andres 9/9/2013 13:56'!
testPromedioConAplazos
self assert: alumno promedioConAplazos equals:6.! !

!TestAlumno methodsFor: 'as yet unclassified' stamp: 'andres 9/9/2013 13:55'!
testPromedioSinAplazo
self assert: alumno promedioSinAplazos equals:8.! !

!TestAlumno methodsFor: 'as yet unclassified' stamp: 'andres 9/10/2013 22:52'!
testTablaDeNotas
self assert: alumno tablaDeNotas equals: #(0 1 0 0 0 0 1 0 1 0).! !

TestCase subclass: #TestGrupos
	instanceVariableNames: 'alumno1 alumno2 alumno3 grupo1 grupo2 experimento1 experimento2 charla proyecto sesion1 sesion2 docente1 docente2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits-Test'!

!TestGrupos methodsFor: 'as yet unclassified' stamp: 'Javi 9/12/2013 03:35'!
setUp 
alumno1 := Alumno new.
alumno2 := Alumno new.
alumno3 := Alumno new.
grupo1 := GrupoInvestigacion new.
grupo2  := GrupoInvestigacion new.
experimento1 := Experimento new.
experimento2 := Experimento new.
charla := Charla new.
proyecto := Proyecto new.
sesion1 := Sesion new.
sesion2  := Sesion new.
docente1:= Docente new. 
docente2 := Docente new.! !

!TestGrupos methodsFor: 'as yet unclassified' stamp: 'Javi 9/12/2013 04:26'!
testActividadesNoAprobadas
self assert: (grupo1 cantActividadesNoAprobadas) equals: 2! !

Object subclass: #Actividad
	instanceVariableNames: 'responsable participantes fechaPresentacion fechaAprobada montoFinanciacion nombre aprobada recursosRequeridos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

!Actividad class methodsFor: 'as yet unclassified' stamp: 'Javi 9/12/2013 04:29'!
new:unString responsable:alguien
|unaActividad|
unaActividad  := self new.
unaActividad nombre:unString.
unaActividad setResponsable:alguien.
^unaActividad.! !

!Actividad methodsFor: 'as yet unclassified' stamp: 'andres 9/12/2013 01:35'!
addParticipante:alguien
	participantes add:alguien.! !

!Actividad methodsFor: 'accessing' stamp: 'luksdlt92 9/12/2013 00:34'!
estaAprobada
	^aprobada.! !

!Actividad methodsFor: 'accessing' stamp: 'andres 9/12/2013 01:34'!
fechaAprobada
	^fechaAprobada.! !

!Actividad methodsFor: 'accessing' stamp: 'andres 9/12/2013 01:34'!
fechaPresentacion
	^fechaPresentacion
" como usar la fecha con la clase Date?
fecha:= Date readFromString: '01/02/1999'. 
Devuelve 2 January 1999 "! !

!Actividad methodsFor: 'accessing' stamp: 'andres 9/12/2013 01:35'!
fechaPresentacion: unaFecha
	fechaPresentacion:=unaFecha.
" como usar la fecha con la clase Date?
fecha:= Date readFromString: '01/02/1999'. 
Devuelve 2 January 1999 "! !

!Actividad methodsFor: 'as yet unclassified' stamp: 'luksdlt92 9/12/2013 01:18'!
initialize
	participantes := Bag new.
	aprobada := false.
	montoFinanciacion := 0.! !

!Actividad methodsFor: 'accessing' stamp: 'andres 9/12/2013 01:35'!
montoFinanciacion
	^montoFinanciacion.! !

!Actividad methodsFor: 'accessing' stamp: 'andres 9/12/2013 01:35'!
montoFinanciacion:unMonto
	montoFinanciacion:=unMonto.! !

!Actividad methodsFor: 'accessing' stamp: 'andres 9/12/2013 01:36'!
participantes
	^participantes.! !

!Actividad methodsFor: 'as yet unclassified' stamp: 'Javi 9/12/2013 04:31'!
setAprobada:unBool enFecha:unaFecha
	aprobada:=unBool.
	fechaAprobada:= unaFecha.! !

!Actividad methodsFor: 'accessing' stamp: 'Javi 9/12/2013 04:29'!
setResponsable: alguien
	responsable:=alguien.! !

Actividad subclass: #Charla
	instanceVariableNames: 'fecha horaInicio horaFin cantEstimadaPublico'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

Actividad subclass: #Proyecto
	instanceVariableNames: 'resultados experimentos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

Actividad subclass: #Seminario
	instanceVariableNames: 'sesiones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

Object subclass: #Alumno
	uses: Estadistica
	instanceVariableNames: 'carrera materias_terminadas materias_abandonadas cursadas vecNotas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

Alumno class
	uses: Estadistica classTrait
	instanceVariableNames: 'vecNotas'!

!Alumno commentStamp: '<historical>' prior: 0!
An Alumno is xxxxxxxxx.

Instance Variables
!

Alumno class
	uses: Estadistica classTrait
	instanceVariableNames: 'vecNotas'!

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:40'!
carrera
	^ carrera! !

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:40'!
carrera: anObject
	carrera := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:54'!
cursadas
	^ cursadas! !

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:54'!
cursadas: anObject
	cursadas := anObject! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'andres 9/10/2013 22:35'!
initialize 
materias_terminadas:= Bag new.
materias_abandonadas:= Bag new.	
cursadas:= Bag new. 
vecNotas:= Array new:10.
! !

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:40'!
materias_abandonadas
	^ materias_abandonadas! !

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:40'!
materias_abandonadas: anObject
	materias_abandonadas := anObject! !

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:40'!
materias_terminadas
	^ materias_terminadas! !

!Alumno methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:40'!
materias_terminadas: anObject
	materias_terminadas := anObject! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'Javi 9/12/2013 03:52'!
obtenerCursadas
^cursadas! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'andres 9/10/2013 09:30'!
obtenerNumero: unObject 
^unObject nota
! !

!Alumno methodsFor: 'as yet unclassified' stamp: 'andres 9/10/2013 22:29'!
obtenerVecNotas
^vecNotas.
! !

Object subclass: #Carrera
	uses: Coleccion + Estadistica
	instanceVariableNames: 'nombre materias'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

!Carrera commentStamp: '<historical>' prior: 0!
A Carrera is xxxxxxxxx.

Instance Variables
	materias:		<Object>

materias
	- xxxxx
!

Carrera class
	uses: Coleccion classTrait + Estadistica classTrait
	instanceVariableNames: ''!

!Carrera methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:18'!
coleccion
	^ materias .! !

!Carrera methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:18'!
coleccion:unaColeccion
	materias := unaColeccion .! !

!Carrera methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:24'!
nombre
	^ nombre! !

!Carrera methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:24'!
nombre: anObject
	nombre := anObject! !

Object subclass: #Cursada
	instanceVariableNames: 'curso nota materia estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

!Cursada commentStamp: '<historical>' prior: 0!
A Cursada is xxxxxxxxx.

Instance Variables
	curso:		<Object>
	materia:		<Object>
	nota:		<Object>

curso
	- xxxxx

materia
	- xxxxx

nota
	- xxxxx
!

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/11/2013 13:56'!
abandono
^estado==1! !

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/11/2013 13:55'!
aprobo
^nota>=4! !

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:55'!
curso
	^ curso! !

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:55'!
curso: anObject
	curso := anObject! !

!Cursada methodsFor: 'accessing' stamp: 'andres 9/10/2013 10:07'!
estado
^estado.! !

!Cursada methodsFor: 'accessing' stamp: 'andres 9/10/2013 10:07'!
estado:algo
estado:=algo.
	! !

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/11/2013 13:57'!
initialize 
estado:=0! !

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:55'!
materia
	^ materia! !

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:55'!
materia: anObject
	materia := anObject! !

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:55'!
nota
	^ nota! !

!Cursada methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:55'!
nota: anObject
	nota := anObject! !

Object subclass: #Curso
	uses: Coleccion + Estadistica
	instanceVariableNames: 'codigo cuatrimestre ao docentes alumnos materia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

!Curso commentStamp: '<historical>' prior: 0!
A Curso is xxxxxxxxx.

Instance Variables
!

Curso class
	uses: Coleccion classTrait + Estadistica classTrait
	instanceVariableNames: ''!

!Curso methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:29'!
ao
	^ ao! !

!Curso methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:29'!
ao: anObject
	ao := anObject! !

!Curso methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:24'!
codigo
	^ codigo! !

!Curso methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:24'!
codigo: anObject
	codigo := anObject! !

!Curso methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:20'!
coleccion
	^ docentes .! !

!Curso methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:20'!
coleccion:unaColeccion
	docentes := unaColeccion .! !

!Curso methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:29'!
cuatrimestre
	^ cuatrimestre! !

!Curso methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:29'!
cuatrimestre: anObject
	cuatrimestre := anObject! !

Object subclass: #Docente
	uses: Estadistica
	instanceVariableNames: 'nombre cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

!Docente commentStamp: '<historical>' prior: 0!
A Docente is xxxxxxxxx.

Instance Variables
!

Docente class
	uses: Estadistica classTrait
	instanceVariableNames: ''!

!Docente methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:41'!
cursos
	^ cursos! !

!Docente methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 15:41'!
cursos: anObject
	cursos := anObject! !

!Docente methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:22'!
nombre
	^ nombre! !

!Docente methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:22'!
nombre: anObject
	nombre := anObject! !

Object subclass: #Experimento
	instanceVariableNames: 'fecha horaInicio horaFin descripcion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

Object subclass: #GrupoInvestigacion
	instanceVariableNames: 'integrantes actividades'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

!GrupoInvestigacion methodsFor: 'accessing' stamp: 'luksdlt92 9/12/2013 01:20'!
actividades
	^actividades.! !

!GrupoInvestigacion methodsFor: 'as yet unclassified' stamp: 'luksdlt92 9/12/2013 00:58'!
aniadirActividad: unaActividad
	actividades add: unaActividad.! !

!GrupoInvestigacion methodsFor: 'as yet unclassified' stamp: 'luksdlt92 9/12/2013 00:57'!
aniadirIntegrante: unIntegrante
	integrantes add: unIntegrante.! !

!GrupoInvestigacion methodsFor: 'as yet unclassified' stamp: 'Javi 9/12/2013 04:29'!
cantActividadesNoAprobadas
^self actividades count:[:actividad | actividad estaAprobada]! !

!GrupoInvestigacion methodsFor: 'as yet unclassified' stamp: 'luksdlt92 9/12/2013 01:01'!
initialize
"Los integrantes y actividades no deberian poder repetirse"
	integrantes := Set new.
	actividades := Set new.! !

!GrupoInvestigacion methodsFor: 'accessing' stamp: 'luksdlt92 9/12/2013 01:20'!
integrantes
	^integrantes.! !

Object subclass: #Materia
	uses: Coleccion + Estadistica
	instanceVariableNames: 'nombre cursos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

!Materia commentStamp: '<historical>' prior: 0!
A Materia is xxxxxxxxx.

Instance Variables
	cursos:		<Object>

cursos
	- xxxxx
!

Materia class
	uses: Coleccion classTrait + Estadistica classTrait
	instanceVariableNames: ''!

!Materia methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:15'!
coleccion
	^cursos ! !

!Materia methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:16'!
coleccion:unaColeccion
	cursos := unaColeccion .! !

!Materia methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:55'!
cursos
	^cursos ! !

!Materia methodsFor: 'accessing' stamp: 'fedecasares 9/5/2013 16:55'!
cursos:unaColeccion
	cursos := unaColeccion .! !

!Materia methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:23'!
nombre
	^ nombre! !

!Materia methodsFor: 'accessing' stamp: 'Fiok 9/3/2013 22:23'!
nombre: anObject
	nombre := anObject! !

Object subclass: #Resultados
	instanceVariableNames: 'fecha descripcion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!

Object subclass: #Sesion
	instanceVariableNames: 'fecha horaInicio horaFin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpTraits'!
